#ifndef btools_h
#define btools_h
#endif


#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

/*
#ifdef PROGMEM
#undef PROGMEM
#define PROGMEM __attribute__((section(".progmem.data")))
#endif
*/

//typedef  unsigned long long  uint64_t  ;
//typedef  unsigned char       uint8_t   ;
//typedef  unsigned long       uint32_t  ;


// #define KTEST

struct rlpitem { char * next   ;
                 char *data    ;
				 uint32_t len   ;
				 uint32_t lhead ;
				 uint32_t is_string  ;
               };

/* 'Words' here refers to uint64_t */
#define SHA3_KECCAK_SPONGE_WORDS \
	(((1600)/8/*bits to byte*/)/sizeof(uint64_t))

typedef struct sha3_context_ {
    uint64_t saved;             /* the portion of the input message that we
                                 * didn't consume yet */
    union {                     /* Keccak's state */
    uint64_t s[SHA3_KECCAK_SPONGE_WORDS];
    uint8_t sb[SHA3_KECCAK_SPONGE_WORDS * 8];
    };
    uint32_t  byteIndex;         /* 0..7--the next byte after the set one
                                 * (starts from 0; 0--none are buffered) */
    uint32_t wordIndex;         /* 0..24--the next word to integrate input
                                 * (starts from 0) */
    uint32_t capacityWords;     /* the double size of the hash output in
                                 * words (e.g. 16 for Keccak 512) */
} sha3_context;


class btools
{
  public:
   btools(Stream &myserial);
   struct rlpitem * decode_rlp(char *buf, uint32_t len, struct rlpitem  * RLP);
   uint32_t encode_rlp(char * val, uint32_t lenv, uint32_t string, char *buf);
   int sha3_256(char *data, size_t datalen, char *digest);
   int sha3_test();

  private:
   Stream* aserial; 
   void keccakf(uint64_t s[25]) ;
   void sha3_Init256(sha3_context * priv);
   void sha3_Init384(sha3_context * priv);
   void sha3_Init512(sha3_context *priv);
   void sha3_Update(sha3_context * priv, void const *bufIn, size_t len);
   void * sha3_Finalize(sha3_context * priv);
};
